/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <Core/Module/Module.h>

#include <QDialog>
#include <QPushButton>
#include <QSharedPointer>
#include <QWidget>

namespace Ui
{
class ModulesPicker;
}

class ModulesPicker : public QDialog
{
    Q_OBJECT

public:
    explicit ModulesPicker();
    ~ModulesPicker() override;

    void addModule(const QString& txt);
    void onModuleSelected(Module* module);
    void onModuleSelected(const QString& mName);
    Module* start();

    //    QWidget* toWidget() override;
    //    XmlObject toXmlObject() override;
    //    void fromXmlObject(const XmlObject &xmlObject) override;

signals:
    void moduleSelected(Module* selectedModule);

protected:
    void createAndConnectUI();
    void connectSlot(QPushButton* button);
    void onCreateModuleButtonClick();
    QPushButton* createButton(const QString& name);

private:
    void createSplitter(Qt::Orientation orientation);

    Ui::ModulesPicker* ui;
    Module** selectedModule = nullptr;
};
