/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <Core/Message/Filter.h>
#include <Modules/DefaultModule/DefaultModule.h>

class IncomingMessagesViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit IncomingMessagesViewerModule(QWidget* parent = nullptr);
    ~IncomingMessagesViewerModule();

    QWidget* toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

private slots:
    void onSubscribeClicked();
    void onFilterAdded(const Filter& filter);
    void onFilterRemoved(const Filter& filter);

private:
    QTextEdit* edit;
    void setupUi();
    void addCustomActionsToMenu() override;

    QList<Filter> filters;

    bool keepOnlyLastMessage = false;
    QAction* keepOnlyLastMessageAction;
    bool useTimestamp = false;
    QAction* useTimestampAction;
};
