/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <QMainWindow>

#include "Core/SkywardHubCore.h"
#include "Window.h"

class SkywardHubMainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit SkywardHubMainWindow(QWidget *parent = nullptr);

protected slots:
    void onPageAdded(int index);
    void onContextMenuRequest(QMenu &menu, const QPoint &p);

private:
    SkywardHubCoreProxy core;
    Window *mainWindow;
};
