/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <QMenu>
#include <QWidget>

#include "Components/ErrorDisplayer/Error.h"
#include "Components/ErrorDisplayer/ErrorDisplayer.h"

class Module;

namespace Ui
{
class Window;
}

class Window : public QWidget
{
    Q_OBJECT

public:
    explicit Window(QWidget *parent = nullptr);
    ~Window();

    void updateModule(Module *m);
    Module *getCentralModule() const;

    void setCentralModule(Module *value);

    ErrorDisplayer *errorDisplayer;

protected:
    void closeEvent(QCloseEvent *event) override;
    void onWidgetDestroyed();
    void onReplaceRequested(Module *sender, Module *newModule);
    void resizeEvent(QResizeEvent *) override;

private:
    Ui::Window *ui;
    Module *centralModule = nullptr;
};
